---
title: Cache-Control
slug: Web/HTTP/Headers/Cache-Control
tags:
  - Cache-Control
  - General Header
  - HTTP
  - HTTP Header
  - Reference
---
<div>{{HTTPSidebar}}</div>

<p><span class="seoSummary">The <strong><code>Cache-Control</code></strong> HTTP header holds <em>directives</em> (instructions) for <a href="/en-US/docs/Web/HTTP/Caching">caching</a> in both requests and responses. A given directive in a request does not mean the same directive should be in the response.</span></p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("General header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("CORS-safelisted response header")}}</th>
   <td>yes</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<p>Caching directives have the following rules to be valid:</p>

<ul>
 <li>Case-insensitive, but lowercase is recommended.</li>
 <li>Multiple directives are comma-separated.</li>
 <li>Some directives have an optional argument, which can be either a <em>token</em> or a <em>quoted-string</em>. (See spec for definitions)</li>
</ul>

<h3 id="Cache_request_directives">Cache request directives</h3>

<p>Standard <code>Cache-Control</code> directives that can be used by the client in an HTTP request.</p>

<pre class="syntaxbox notranslate">Cache-Control: max-age=&lt;seconds&gt;
Cache-Control: max-stale[=&lt;seconds&gt;]
Cache-Control: min-fresh=&lt;seconds&gt;
Cache-Control: no-cache
Cache-Control: no-store
Cache-Control: no-transform
Cache-Control: only-if-cached
</pre>

<h3 id="Cache_response_directives">Cache response directives</h3>

<p>Standard <code>Cache-Control</code> directives that can be used by the server in an HTTP response.</p>

<pre class="syntaxbox notranslate">Cache-Control: must-revalidate
Cache-Control: no-cache
Cache-Control: no-store
Cache-Control: no-transform
Cache-Control: public
Cache-Control: private
Cache-Control: proxy-revalidate
Cache-Control: max-age=&lt;seconds&gt;
Cache-Control: s-maxage=&lt;seconds&gt;
</pre>

<h3 id="Extension_Cache-Control_directives">Extension Cache-Control directives</h3>

<p>Extension <code>Cache-Control</code> directives are not part of the core HTTP caching standards document. Check the <a href="#Browser_compatibility">compatibility table</a> for their support; user-agents that don't recognize them should ignore them.</p>

<pre class="syntaxbox notranslate">Cache-Control: immutable
Cache-Control: stale-while-revalidate=&lt;seconds&gt;
Cache-Control: stale-if-error=&lt;seconds&gt;
</pre>

<h2 id="Directives">Directives</h2>

<h3 id="Cacheability">Cacheability</h3>

<p>Directives that define whether a response/request can be cached, where it may be cached, and whether it must be validated with the origin server before caching.</p>

<dl>
 <dt><code>public</code></dt>
 <dd>The response may be stored by <em>any</em> cache, even if the response is normally non-cacheable.</dd>
 <dt><code>private</code></dt>
 <dd>The response may be stored only by a <em>browser's</em> cache, even if the response is normally non-cacheable. <strong>If you mean to not store the response in any cache, use <code>no-store</code> instead.</strong> <em>This directive is not effective in preventing caches from storing your response.</em></dd>
 <dt><code>no-cache</code></dt>
 <dd>The response may be stored by <em>any</em> cache, even if the response is normally non-cacheable. However, the stored response MUST <em>always</em> go through validation with the origin server first before using it, therefore, you cannot use <code>no-cache</code> in-conjunction with <code>immutable</code>. <strong>If you mean to not store the response in any cache, use <code>no-store</code> instead.</strong> <em>This directive is not effective in preventing caches from storing your response.</em></dd>
 <dt><code>no-store</code></dt>
 <dd>The response may <strong>not</strong> be stored in <em>any</em> cache. Note that this will not prevent a valid <em>pre-existing</em> cached response being returned. Clients can set <code>max-age=0</code> to also clear existing cache responses, as this forces the cache to revalidate with the server (no other directives have an effect when used with <code>no-store</code>).</dd>
</dl>

<h3 id="Expiration">Expiration</h3>

<dl>
 <dt><code>max-age=&lt;seconds&gt;</code></dt>
 <dd>The maximum amount of time a resource is considered fresh. Unlike <code>Expires</code>, this directive is relative to the time of the request.</dd>
 <dt><code>s-maxage=&lt;seconds&gt;</code></dt>
 <dd>Overrides <code>max-age</code> or the <code>Expires</code> header, but only for shared caches (e.g., proxies). Ignored by private caches.</dd>
 <dt><code>max-stale[=&lt;seconds&gt;]</code></dt>
 <dd>Indicates the client will accept a stale response. An optional value in seconds indicates the upper limit of staleness the client will accept.</dd>
 <dt><code>min-fresh=&lt;seconds&gt;</code></dt>
 <dd>Indicates the client wants a response that will still be fresh for <em>at least</em> the specified number of seconds.</dd>
 <dt><code>stale-while-revalidate=&lt;seconds&gt;</code> {{Experimental_Inline}}</dt>
 <dd>Indicates the client will accept a stale response, while asynchronously checking in the background for a fresh one. The <em>seconds</em> value indicates how long the client will accept a stale response. See "<a href="https://web.dev/stale-while-revalidate">Keeping things fresh with <code>stale-while-revalidate</code></a>" for more information.</dd>
 <dt><code>stale-if-error=&lt;seconds&gt;</code> {{Experimental_Inline}}</dt>
 <dd>Indicates the client will accept a stale response if the check for a fresh one fails. The <em>seconds</em> value indicates how long the client will accept the stale response after the initial expiration.</dd>
</dl>

<h3 id="Revalidation_and_reloading">Revalidation and reloading</h3>

<dl>
 <dt><code>must-revalidate</code></dt>
 <dd>Indicates that once a resource becomes stale, caches must not use their stale copy without successful <a href="/en-US/docs/Web/HTTP/Caching#Cache_validation">validation</a> on the origin server.</dd>
 <dt><code>proxy-revalidate</code></dt>
 <dd>Like <code>must-revalidate</code>, but only for shared caches (e.g., proxies). Ignored by private caches.</dd>
 <dt><code>immutable</code></dt>
 <dd>Indicates that the response body <strong>will not change</strong> over time. The resource, if <em>unexpired</em>, is unchanged on the server and therefore the client should not send a conditional revalidation for it (e.g. <code>If-None-Match</code> or <code>If-Modified-Since</code>) to check for updates, even when the user explicitly refreshes the page. Clients that aren't aware of this extension must ignore them as per the HTTP specification. In Firefox, <code>immutable</code> is only honored on <code>https://</code> transactions. For more information, see also this <a href="https://bitsup.blogspot.de/2016/05/cache-control-immutable.html">blog post</a>.</dd>
</dl>

<h3 id="Other">Other</h3>

<dl>
 <dt><code>no-transform</code></dt>
 <dd>An intermediate cache or proxy cannot edit the response body, {{HTTPHeader("Content-Encoding")}}, {{HTTPHeader("Content-Range")}}, or {{HTTPHeader("Content-Type")}}. It therefore forbids a proxy or browser feature, such as <a href="https://support.google.com/webmasters/answer/6211428">Google’s Web Light</a>, from converting images to minimize data for a cache store or slow connection.</dd>
 <dt><code>only-if-cached</code></dt>
 <dd>Set by the <em>client</em> to indicate "do not use the network" for the response. The cache should either respond using a stored response, or respond with a {{HTTPStatus("504")}} status code. Conditional headers such as <code>If-None-Match</code> should not be set. There is no effect if <code>only-if-cached</code> is set by a server as part of a response.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Preventing_caching">Preventing caching</h3>

<p>To disable caching of a resource, you can send the following response header:</p>

<dl>
 <dt>Good:</dt>
 <dd>
 <pre class="example-good brush: http no-line-numbers notranslate">Cache-Control: no-store</pre>

 <div class="notecard note">
 <p>The <code>no-store</code> directive will prevent a new resource being cached, but it will not prevent the cache from responding with a non-stale resource that was cached as the result of an earlier request. Setting <code>max-age=0</code> as well forces the cache to revalidate (clears the cache).</p>

 <pre class="syntaxbox notranslate">Cache-Control: no-store, max-age=0
</pre>
 </div>
 </dd>
 <dt>Bad:</dt>
 <dd>
 <pre class="example-bad brush: http no-line-numbers notranslate">Cache-Control: private,no-cache,no-store,max-age=0,must-revalidate,pre-check=0,post-check=0</pre>
 </dd>
</dl>

<h3 id="Caching_static_assets">Caching static assets</h3>

<p>For the files in the application that will not change, you can usually add aggressive caching by sending the response header below. This includes static files that are served by the application such as images, CSS files and JavaScript files, for example. In addition, see also the <code>Expires</code> header.</p>

<pre class="brush: http no-line-numbers notranslate">Cache-Control: public, max-age=604800, immutable
</pre>

<h3 id="Requiring_revalidation">Requiring revalidation</h3>

<p><code>no-cache</code> and <code>max-age=0, must-revalidate</code> indicates same meaning.<br>
 Clients can cache a resource but must revalidate each time before using it. This means HTTP request occurs each time though, it can skip downloading HTTP body if the content is valid.</p>

<pre class="brush: http no-line-numbers notranslate">Cache-Control: no-cache</pre>

<pre class="brush: http no-line-numbers notranslate">Cache-Control: max-age=0, must-revalidate</pre>

<p><strong>Note</strong>: Following may serve stale resource if server is down or lose connectivity.</p>

<pre class="brush: http no-line-numbers notranslate">Cache-Control: max-age=0</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC(8246, "HTTP Immutable Responses")}}</td>
   <td><span class="spec-RFC">IETF RFC</span></td>
   <td></td>
  </tr>
  <tr>
   <td>{{RFC(7234, "Hypertext Transfer Protocol (HTTP/1.1): Caching")}}</td>
   <td><span class="spec-RFC">IETF RFC</span></td>
   <td></td>
  </tr>
  <tr>
   <td>{{RFC(5861, "HTTP Cache-Control Extensions for Stale Content")}}</td>
   <td><span class="spec-RFC">IETF RFC</span></td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("http.headers.Cache-Control")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTTP/Caching_FAQ">HTTP Caching FAQ</a></li>
 <li><a href="https://www.mnot.net/cache_docs/">Caching Tutorial for Web Authors and Webmasters</a></li>
 <li>Guide: <em><a href="https://csswizardry.com/2019/03/cache-control-for-civilians"><code>Cache-Control</code> for civilians</a></em></li>
 <li>{{HTTPHeader("Age")}}</li>
 <li>{{HTTPHeader("Expires")}}</li>
 <li>{{HTTPHeader("Pragma")}}</li>
</ul>
